/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { AnchoredRadialSeries } from "./AnchoredRadialSeries";
import { UnknownValuePlotting_$type } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
import { Array_$type, runOn, enumGetBox, markType, markDep } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { ChartSelection } from "./ChartSelection";
import { PropertyMetadata } from "igniteui-angular-core";
import { AnchoredRadialSeriesView } from "./AnchoredRadialSeriesView";
import { Defaults } from "./Defaults";
import { Color } from "igniteui-angular-core";
/**
 * @hidden
 */
export let RadialLineSeries = /*@__PURE__*/ (() => {
    class RadialLineSeries extends AnchoredRadialSeries {
        constructor() {
            super();
            this.ab = RadialLineSeries.$;
        }
        bk() {
            return new RadialLineSeries();
        }
        get_fl() {
            return true;
        }
        ct() {
            return new RadialLineSeriesView(this);
        }
        q7(a) {
            super.q7(a);
            this.adx = a;
        }
        ac() {
            super.ac();
        }
        preferredCategoryMode(a) {
            return 0;
        }
        z6() {
            return true;
        }
        pb(a, b) {
            super.pb(a, b);
            let c = b;
            c.dj();
        }
        abk(a, b) {
            super.abk(a, b);
            let c = b.ca;
            let d = b.b9;
            let e = b.getEffectiveViewport();
            let f = a.h;
            let g = f.count;
            let h = new List$1(Array_$type, 2, g);
            let i = 0;
            for (let j = 0; j < g; j++) {
                let k = new Array(4);
                h.add(k);
                k[0] = this.zg.d(a.h._inner[j][0], a.h._inner[j][1], c, d, e);
                k[1] = this.zg.e(a.h._inner[j][0], a.h._inner[j][1], c, d, e);
                k[2] = this.zg.d(a.h._inner[j][0], a.h._inner[j][2], c, d, e);
                let l = a.h._inner[j][2];
                k[3] = this.zg.e(a.h._inner[j][0], l, c, d, e);
                if (l > i) {
                    i = l;
                }
            }
            let m = this.getEffectiveViewport1(b);
            this.zo.a2(this, this.z5(), runOn(this, this.yx), this.aae(b), this.aaf(b));
            let n = false;
            let o = this.zo.b;
            if (o != null) {
                n = true;
            }
            if (n) {
                let p = new ScalerParams(0, b.ca, b.b9, this.y9.df, m);
                this.add(f, -1, this.acg.count, this.y9, p, b.t);
            }
            let q = b;
            let r = q.dt;
            let s = q.du;
            let t = q.ds;
            this.zo.ad(r, true, false, true, false);
            this.zo.ad(s, true, false, true, false);
            this.zo.ad(t, false, true, false, false);
            t._opacity = 0.75 * this.zo.j;
            q.dk(g, h, false, this.ady, this.ab9(h, g - 1, b), q.da.b, this.ie);
        }
        rg(a, b, c, d) {
            super.rg(a, b, c, d);
            switch (b) {
                case RadialLineSeries.$$p[0]:
                    this.ry(false);
                    this.qr();
                    break;
            }
        }
        get_acm() {
            return true;
        }
        ak(a, b) {
            let c = new List$1(ChartSelection.$, 0);
            this.qa(a, c, b);
            return c.toArray();
        }
        qa(a, b, c) {
            this.ada(a, b, c, this.za);
        }
    }
    RadialLineSeries.$t = markType(RadialLineSeries, 'RadialLineSeries', AnchoredRadialSeries.$);
    RadialLineSeries.$$p = markDep(DependencyProperty, PropertyMetadata, RadialLineSeries, 'raisePropertyChanged', ['UnknownValuePlotting:ady:ad0', [UnknownValuePlotting_$type, enumGetBox(UnknownValuePlotting_$type, 1)]]);
    return RadialLineSeries;
})();
/**
 * @hidden
 */
export let RadialLineSeriesView = /*@__PURE__*/ (() => {
    class RadialLineSeriesView extends AnchoredRadialSeriesView {
        constructor(a) {
            super(a);
            this.di = null;
            this.dq = new Path();
            this.dp = new Path();
            this.dr = new Path();
            this.dm = new Path();
            this.dl = new Path();
            this.dn = new Path();
            this.di = a;
        }
        a4() {
            super.a4();
            if (!this.t) {
                this.ch.xk = Defaults.e;
            }
        }
        get dt() {
            return this.dq;
        }
        get du() {
            return this.dr;
        }
        get ds() {
            return this.dp;
        }
        dj() {
            this.dq.an = null;
            this.dp.an = null;
            this.dr.an = null;
            this.dm.an = null;
            this.dl.an = null;
            this.dn.an = null;
            this.a2();
        }
        dk(a, b, c, d, e, f, g) {
            this.de.acb.m(this.dq, this.dp, this.dr, a, b, c, d, e, f, g);
            this.a2();
        }
        bp() {
            super.bp();
        }
        bq() {
            super.bq();
            let a = this.b3();
            this.dl.an = this.dp.an;
            this.dm.an = this.dq.an;
            this.dn.an = this.dr.an;
            this.dm._stroke = a;
            this.dm.ad = this.f.ig + 3;
            this.dn._stroke = a;
            this.dn.ad = this.f.ig + 3;
            this.dl._fill = a;
            this.dl._opacity = 1;
        }
        bj(a, b) {
            super.bj(a, b);
            if (a.d) {
                if (b) {
                    a.t(this.dl);
                    a.t(this.dm);
                    a.t(this.dn);
                }
                else {
                    a.t(this.dp);
                    a.t(this.dq);
                    a.t(this.dr);
                }
            }
        }
        ax(a) {
            super.ax(a);
            this.f.bc.exportPathData(a, this.dq, "lowerShape", ["Lower", "Main"]);
            this.f.bc.exportPathData(a, this.dr, "upperShape", ["Upper"]);
            this.f.bc.exportPathData(a, this.dp, "translucentShape", ["Translucent"]);
        }
        an() {
            let a = new Color();
            a.colorString = "rgba(95,95,95,0.5)";
            this.f.wb = a;
            this.f.jq = 3;
            this.f.jr = 1;
            this.f.js = 4;
            this.f.hd = false;
        }
    }
    RadialLineSeriesView.$t = markType(RadialLineSeriesView, 'RadialLineSeriesView', AnchoredRadialSeriesView.$);
    return RadialLineSeriesView;
})();
